import java.io.*;
import java.util.ArrayList;

public class Middleware {

	  private ArrayList<MyGrfObject> grafikliste = new ArrayList<MyGrfObject>();
	  private String filename;
	  
	  public Middleware() {
	    filename="";
	  }

	  public void setFilename(String filename) {
	    this.filename = filename;
	  }
	  public String getFilename() {
	    return filename;
	  }

	  public ArrayList getGrafikliste() {
	    return grafikliste;
	  }

	  private  int width = 0;
	  private int height = 0;

	  public int getWidth() {
	    return width;
	  }

	  public int getHeight() {
	    return height;
	  }

	 public void readFile( String filename) {
	    FileInputStream fin;
	    DataInputStream din;

	    MyHeader header;
	    MyCircle circle;
	    MyLine   line;
	    MyRect   rect;
	    MyTriangle dreieck;
	    MyPolyline polyline;

	    // Einlesen des Headers
	    // Gre setzen
	    // Eintragen der grafischen Elemente
	    this.filename = filename;

	    try {
	      fin = new FileInputStream(filename);
	      din = new DataInputStream(fin);

	      header = new MyHeader();
	      if (header.loadFromData(din)) { // Absturz mit Exception

	        width = header.getWidth();
	        height = header.getHeight();
	         grafikliste.clear();
	         short typ = din.readShort();
	         while (typ != 0) {
	            switch (typ) {
	              case Konstanten.C_Line:    
	                         line = new MyLine();
	                         if (!line.loadFromData(din)) {
	                           Basis.errorBox("Fehler beim Lesen einer Linie","Fehler");
	                           return;
	                         }
	                         grafikliste.add(line);
	                        break;
	              case Konstanten.C_Rect:   
	                         rect = new MyRect();
	                         if (!rect.loadFromData(din)) {
	                           Basis.errorBox("Fehler beim Lesen eines Rechtecks","Fehler");
	                           return;
	                         }
	                         grafikliste.add(rect);
	                       break;
	              case Konstanten.C_Circle:  
	                         circle = new MyCircle();
	                         if (!circle.loadFromData(din)) {
	                           Basis.errorBox("Fehler beim Lesen eines Kreises","Fehler");
	                           return;
	                         }
	                         grafikliste.add(circle);
	                       break;
	              case Konstanten.C_Dreieck:  
	                         dreieck = new MyTriangle();
	                         if (!dreieck.loadFromData(din)) {
	                           Basis.errorBox("Fehler beim Lesen eines Dreiecks","Fehler");
	                           return;
	                         }
	                         grafikliste.add(dreieck);
	                       break;
	              case Konstanten.C_Polylinie:  
	                         polyline = new MyPolyline();
	                         if (!polyline.loadFromData(din)) {
	                           Basis.errorBox("Fehler beim Lesen einer PolyLinie","Fehler");
	                           return;
	                         }
	                         grafikliste.add(polyline);
	                       break;
	              default:   
	                   Basis.errorBox("Fehler beim Switch/Case in Modul Middleware, readfile typ: "+typ,"Fehler");
	                   break;
	           }  // switch
	           typ = din.readShort();
	         }  // while

	     } // if loadFromHeader
	     else {
	       // Basis.errorBox("Fehler beim Einlesen des Headers","Fehler");
	     }
	     din.close();      
	    }
	    catch (IOException ee) {
	         System.err.println("Fehler beim Einlesen der Datei: " + filename +"\n" + ee);
	     }
	  }  // readFile

	}  // Middleware